﻿using C1.DataEngine;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Dynamics365Analytics
{
    public partial class Form2 : Form
    {
        PivotService svc;
        public Form2()
        {
            InitializeComponent();
            dataGridView1.Visible = false;
            this.svc = new PivotService();

           // RefreshData();

            var queries = new List<string> { "OpportunityByStage", "ProductOppportunity", "OpportunityByRep", "OpportunityByFiscalQuarter" };
            comboBox1.DataSource = queries;
            comboBox1.SelectedIndex = -1;
            comboBox1.SelectedIndexChanged += (s, e) =>
            {
                var item = (s as ComboBox).SelectedItem.ToString();
                this.InvokeMethod(this.svc, item);
            };
        }

        public void InvokeMethod(object className, string method)
        {
            var mt = className.GetType().GetMethod(method);
            var list = mt.Invoke(className, new object[] { });
            dataGridView1.DataSource = list;
            dataGridView1.Visible = true;
            pivot.DataSource = list;
            
        }

        private void RefreshData()
        {
           // IDataList OpportunityList = this.svc.Workspace.GetTableData("Opportunities");
            if (this.svc.Workspace.GetTableData("Opportunities") == null || Properties.Settings.Default.threshhold.Date<DateTime.Now.Date)
            {
                this.svc.GetData();
            }
        }

        private void Form2_Load(object sender, EventArgs e)
        {
           
        }
    }
}
